//+------------------------------------------------------------------+
//|                                                       ATR_BB.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+
#property indicator_separate_window

#property indicator_buffers 5

#property indicator_color1 clrMagenta
#property indicator_color2 clrDarkSlateGray
#property indicator_color3 clrDarkSlateGray
#property indicator_color4 clrDarkSlateGray
#property indicator_color5 clrNONE


//---- input parameters
extern int ATR_period = 21;
extern int BB_period = 20;
extern double BB_deviation = 2.0;

extern int NumberOfBarsToCalculate = 10000;

//---- indicator buffers
double Buffer_ATR[];
double Buffer_BB_upper[];
double Buffer_BB_main[];
double Buffer_BB_lower[];

double Buffer_VB[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorDigits(Digits-1);
      
//---- indicator line
   //ATR
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
   //Bollinger
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,3);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,3);
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,3);
   
   SetIndexStyle(4,DRAW_NONE);
   
//----
   SetIndexBuffer(0,Buffer_ATR);
   SetIndexBuffer(1,Buffer_BB_upper);
   SetIndexBuffer(2,Buffer_BB_lower);
   SetIndexBuffer(3,Buffer_BB_main);
   SetIndexBuffer(4,Buffer_VB);
   
       
//---- 
   //SetIndexEmptyValue(0, 0.0);
   //SetIndexEmptyValue(1, 0.0);
   //SetIndexEmptyValue(2, 0.0);
   //SetIndexEmptyValue(3, 0.0);
   //SetIndexEmptyValue(4, 0.0);

//----   
   string short_name;
   short_name = "ATR("+ATR_period+") + BB(" + BB_period + ") => ";
   IndicatorShortName(short_name);
   

//----
   return(0);
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start() 
{
 
   int shift;
   
   //ATR
   for(shift=NumberOfBarsToCalculate-1;shift>=0;shift--)
   {
      Buffer_ATR[shift] = iATR(Symbol(),Period(),ATR_period,shift);   
      
   }
   
   
   //Bollinger on ATR
   for(shift=NumberOfBarsToCalculate-1;shift>=0;shift--)
   {
      
      Buffer_BB_upper[shift] = iBandsOnArray(Buffer_ATR, 0, BB_period, BB_deviation, 0, MODE_UPPER, shift);
      Buffer_BB_lower[shift] = iBandsOnArray(Buffer_ATR, 0, BB_period, BB_deviation, 0, MODE_LOWER, shift);
      Buffer_BB_main[shift] = iBandsOnArray(Buffer_ATR, 0, BB_period, BB_deviation, 0, MODE_MAIN, shift);
      
   }
   
   
   //Populate buffer for VB
   for(shift=NumberOfBarsToCalculate-1;shift>=0;shift--)
   {
      
      if(Buffer_ATR[shift] > Buffer_BB_main[shift])
      {
         Buffer_VB[shift] = 1.0;
      
      }
   
   }

   return(0);
}


//+------------------------------------------------------------------+